#ifndef __UPF_CXX_ARGS_OBJ_H__
#define __UPF_CXX_ARGS_OBJ_H__


namespace upf
{

// upf object I/O:
inline Arguments& operator<<(Arguments& holder, IObject* obj)
{
    upf_Object *value = obj ? obj->_upf_getABIObject() : NULL;
    holder.write(&value, sizeof(value));
    // add one reference, so that the object lives for the duration of data
    // transfer (i.e. till it is unmarshalled with operator>>):
    if (value) value->refCnt++;
    return holder;
}

template<class T>
inline Arguments& operator>>(Arguments& holder, ::upf::Ptr<T>& obj)
{
    upf_Object *value;
    holder.read(&value, sizeof(value));
    obj = value ? _makeCxxObject<T>(value) : (T*)NULL;
    // decrement refCount of unmarshalled object (was incremented by operator<<):
    if (value) value->refCnt--;
    return holder;
}

} // end of namespace 'upf'


#endif
