
#ifndef __UPF_PLATFORM_H__
#define __UPF_PLATFORM_H__

/* ----------------------------------------------------------------------
                               GNU C++ compiler
   ---------------------------------------------------------------------- */

#if defined(__GNUC__)
#define _UPF_PRAGMA_PACK_GNU
#endif


/* ----------------------------------------------------------------------
                                  Intel C++
   ---------------------------------------------------------------------- */

#if defined(__INTEL_COMPILER)
#define _UPF_PRAGMA_PACK_WIN32
#endif



/* ----------------------------------------------------------------------
                               Unix platforms
   ---------------------------------------------------------------------- */

#if defined(__unix__) || defined(__linux__)

#define __UPF_UNIX__ 1
#define _UPF_EXPORTED_SYMBOL _UPF_EXTERN_C
#define _UPF_ALWAYS_EXPORTED_SYMBOL _UPF_EXTERN_C
#define _UPF_CALLING_CONVENTION
#define _UPF_FUNCNAME_PREFIX 

#endif


/* ----------------------------------------------------------------------
                                Windows platform
   ---------------------------------------------------------------------- */

#if defined(_WIN32) || defined(WIN32) || defined(__WIN32__)

#define __UPF_WIN32__ 1
#ifdef UPF_BUILDING_CORE
    #define _UPF_EXPORTED_SYMBOL _UPF_EXTERN_C __declspec(dllexport)
#else
    #define _UPF_EXPORTED_SYMBOL _UPF_EXTERN_C __declspec(dllimport)
#endif 
#define _UPF_ALWAYS_EXPORTED_SYMBOL _UPF_EXTERN_C __declspec(dllexport)
#define _UPF_CALLING_CONVENTION __cdecl

#ifndef _UPF_PRAGMA_PACK_GNU
#define _UPF_PRAGMA_PACK_WIN32
#endif

#endif



#endif
    /* __UPF_PLATFORM_H__ */
