
# upf's XML to source code converter

import sys

def getOptions():
    return """\
      -Llanguage      Specify output language. Supported languages are:
                          cxx
"""

def run(argv):
    import getopt, os, os.path

    def usage():
        print "\nUsage:", argv[0], "-o<output_file> -L<language> [flags] file.upface"
        print """
    The supported flags are:

      -ofilename      Name of the file to write interface description to
""" + getOptions()

    try:
        opts, files = getopt.getopt(argv[1:], "ho:L:")
    except getopt.GetoptError:
        usage()
        sys.exit(2)

    output = None
    lang = None

    for o, a in opts:
        if o == '-h':
            usage()
            sys.exit()
        if o == '-o':
            if output != None:
                sys.stderr.write('Multiple output files specified!');
            output = a.replace('\\','/')
        if o == '-L':
            if lang != None:
                sys.stderr.write('Multiple output languages specified!');
            lang = a

    if output == None: output = '-' # stdout

    if lang == None:
        sys.stderr.write('Output language not specified!\n')
        usage()
        sys.exit(2)

    try:
        exec ("""\
from upfparser import out_%s
generate_func = out_cxx.generate
""" % lang) in globals(),locals()

    except:
        sys.stderr.write('Output language not supported!\n')
        usage()
        sys.exit(2)

    file = files[0]

    if file == '-':
        fI = sys.stdout
    else:
        fI = open(file, 'rt')

    if output == '-':
        fO = sys.stdout
    else:
        fO = open(output, 'wt')

    generate_func(fI, fO)

    if file != '-':
        fI.close()
    if output != '-':
        fO.close()

if __name__ == "__main__":
    run(sys.argv)
